// Name
// Student ID

import fisica.*;

// A "stop list" -- a list of words that you want to
// exclude from the word cloud.  Most of the time, 
// words like "the" and "a" will dominate any text, 
// but in a boring way.  Use IntDict and map every
// word in the stop list to the number 1.  Then, you
// can use stopwords.hasKey( w ) to see if w is one of
// the stop words.
// This list comes from the website tagcrowd.com
IntDict stopwords;

// A dictionary that tells you, for every word in the
// main text, how many times it appears.  Every time you
// see a word you add one to its entry in this dictionary.
// We'll use the text of a number of Hillary Clinton 
// emails, downloaded from kaggle.com.
IntDict counts;

// The Fisica (Fisica!) world that we'll use to hold
// all the words.
FWorld world;

void setup()
{
  size( 600, 400 );

  // Set up the Fisica world.
  Fisica.init( this );
  world = new FWorld();
  world.setEdges();
  world.setGravity( 0, 0 );

  // Initialize the stop list.
  stopwords = new IntDict();
  // TODO: read in the file "stopwords.txt".  For
  // every line in that file, add it to the stopwords
  // dictionary by associating it with the value 1.
  // (This should take about 3-6 lines of code.)

  counts = new IntDict();
  // TODO: read in the file "bodies.txt".  For every
  // line, extract all the words in that line.  Use
  // splitTokens() with the string " .,;:\"'!?()[]/<>"
  // as the delimiter.  For every word in that line,
  // if the word isn't in the stop list then
  // either associate the word with a count of 1
  // (if the word hasn't been seen yet) or increase
  // the existing count by one.  You may want to
  // have a look at the .add() method of IntDict.
  // (This should take 8-15 lines of code.)

  // We now need to extract the words in the counts
  // dictionary that occurred the most times.  Amazingly,
  // there's a nice way to do that.  First, we call this
  // method of IntDict:
  counts.sortValuesReverse();

  // Once you do that, the dictionary is reorganized
  // internally so that the entries with the highest
  // _values_ (i.e., the highest occurrence counts)
  // come first.  So, you can use counts.keys() to
  // get an array of Strings in decending order of
  // occurrence counts, and take the first N elements
  // of that array to get the words you want to display.
  
  // TODO: Create WordRect instances for each of the top N
  // words.  Set an initial scaling factor to be passed
  // in to the WordRect constructor.  Multiply that
  // scaling factor by about 0.95 after adding each word,
  // so that words get smaller.  Add each WordRect to the
  // Fisica world.  Choose N and the scaling factor so
  // that you get a decent distribution of word sizes.
  // (This should take about 8-15 lines of code.)
  
  // The following code is for example purposes only.  You
  // can delete it once you understand it.
  world.add( new WordRect( "One", 10.0 ) );
  world.add( new WordRect( "Two", 7.0 ) );
  world.add( new WordRect( "Three", 4.0 ) );
}

// You shouldn't have to change anything here.
void draw()
{
  background( 255 );
  world.step();
  world.draw();
}